<template>
  <div :class="$style.tab" :style="tabWrapperStyle">
    <div :class="$style.tabTitles">
      <tab-title
        @onClick="changeTab"
        v-for="(item, index) in titles"
        :key="index"
        :index="index"
        :isActive="selected === index"
        >{{ item | upperCase }}</tab-title
      >
      <div :class="$style.actionBarWrapper">
        <slot name="actionsBar"></slot>
      </div>
    </div>

    <div
      :class="$style.tabContents"
      :style="{ transform: `translate(-${transformXInPx}px,0` }"
    >
      <slot name="content"></slot>
    </div>
    <div :class="$style.loading"><slot name="loading"></slot></div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
// @ts-ignore
import TabTitle from "@/components/base/BaseTab/tab-title/TabTitle";
// @ts-ignore
import TabContent from "@/components/base/BaseTab/tab-content/TabContent";
const Tab = Vue.extend({
  name: "BaseTab",
  components: {
    TabTitle
  },
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    titles: {
      type: Array,
      required: true
    },
    content: {
      type: Array
    },
    config: {
      type: Object,
      required: true,
      default: function() {
        return {
          width: 1200
        };
      }
    }
  },
  data: function() {
    return {
      selected: 0,
      tabWrapperStyle: {
        width: `${this.config.width}px`
      },
      transformXInPx: 0
    };
  },
  methods: {
    changeTab: function(selected: number) {
      this.selected = selected;
      this.transformXInPx = this.selected * this.config.width;
    }
  }
});
export default Tab;
</script>

<style module lang="scss">
.tab {
  margin: 0 auto;
  overflow: hidden;
}
.tabTitles {
  display: flex;
  justify-content: center;
  align-items: center;
  border-bottom: 1px solid $color--border;
}
.tabContents {
  display: flex;
  transition: all 0.3s;
}
.actionBarWrapper {
  margin-left: 1rem;
}
.loading {
  margin-top: 3rem;
}
</style>
